Actogram <-
function (startX, endX, Avg=1, lum=4, sizePts=2, binPts=15, modulo=1440,myData,fileName,startData) {
#  starting column, ending column, Average or Individual, #minutes between points, # points to bin, # minutes/unit (usually day), data, dark onset

  require(MASS)
  #  12960/15 = 864    864/48=18
  # total pts/newBin = total pts graphed/bins per day  = #days

  CatBins<-CatBin(startX, endX, Avg, lum, sizePts, binPts,modulo, 1, myData)
  # returns newMinPerBin,dataPts,binsPerDay,dayPts,dayCnt,animals, endData, DataList,plotCnt
  # use all data (startdata-1);  startData value is dark onset
  
  DataList<-CatBins$DataList
  TimeBins<-CatBins$TimeBins
  startDark <-as.character(format(as.POSIXct(myData[startData,1], origin="1970-01-01",tz="GMT"),"%H:%M:%S"))    #  get index of first darkness value
  op<-par()
  thisTime <- format(Sys.time(), "%b %d, %Y - %H:%M:%S");
  
  nameVector = paste(" ",names(myData),sep=" ")
  newDayCnt <- floor(CatBins$dataPts/(modulo/sizePts))
  print(newDayCnt)
for (cnt in 1:CatBins$plotCnt) {      #  1 plot per animal, for all animals 
    par(new=FALSE)
    par(mfrow=c((newDayCnt+4),1),mar = c(0, 5, 0, 0),oma=c(1,1,4,1))    #debug specify height of each graph.  width?

    for (i in 1:(newDayCnt)) {     #  1 subplot per day for this animal (row)
      startPt <- ((i-1)*CatBins$dayPts)+1;   #  get data points for this day
      endPt <- i*CatBins$dayPts; 
      #print(endPt)
      #print(i)
      if (i != newDayCnt){    
        #View(DataList[cnt,startPt:endPt])
        barplot(DataList[cnt,startPt:endPt],ylab=endPt)
        #print(head(format(as.POSIXct(TimeBins[startPt:endPt], origin="1970-01-01", tz="GMT"),"%H:%M")))
      } else {
        barplot(DataList[cnt,startPt:endPt],ylab=endPt,names.arg = substr(TimeBins[startPt:endPt],12,16),axis.lty = 1)
        #format(as.POSIXct(TimeBins[startPt:endPt], origin="1970-01-01", tz="GMT"),"%H:%M"))
        #cat(formatC(par("xaxp"), width=5),";",  T<-axTicks(1),"\n")
        #format(as.POSIXct(TimeBins[startPt:endPt], origin="1970-01-01", tz="GMT"),"%H:%M"),"\n")
        #rug(, col= adjustcolor("red", 0.5), lwd = 4)
        #TimeBins[startPt:endPt]
        #axis(1,seq(1,newDayCnt),labels=FALSE)
        #pretty(seq(1,newDayCnt,by=3))
      }
      labelLoc = (max(DataList[cnt,startPt:endPt])-min(DataList[cnt,startPt:endPt])) *.4
      text(binPts/2,labelLoc,labels=TimeBins[startPt])
      #abline(v=startDark,type="dashed")
    }  # end for (i in 1:newDayCnt)
    mtext(paste("Actogram:  Each row is",modulo,"min;  bars are activity levels during each interval."),line=1, side=3, outer=TRUE)
    
    if (Avg)  {    
        mtext(paste('Avg across -',CatBins$animals,'- Animals: ',nameVector[startX],' - ',nameVector[endX],'\nStart time:',myData[startData,1],';    ',newDayCnt,' rows;  ',sizePts,' min intervals\nmod: ',modulo,';     pts/bin: ',binPts,' (',sizePts*binPts,'mins);     total pts: ',CatBins$dataPts," (",startData,"-",CatBins$endData+startData,")"),side=1, line=5, cex =.9)
    } else {
      mtext(paste('Animal -',cnt,': ',nameVector[cnt+3],' \nStart time:',myData[1,1],';   ',newDayCnt,' rows;  ',sizePts,' min intervals\nmod: ',modulo,';     pts/bin: ',binPts,'(',sizePts*binPts,'mins);     total pts: ',CatBins$dataPts," (",startData,"-",CatBins$endData+startData,")"), side=1, line=5, cex =.9)
    }  # add file name, and # minutes per bin
    
    mtext(paste("Dark onset:",startDark[1]),side=1,line = 7, cex =.8, adj=.01)
    mtext(paste(fileName,"   ",thisTime),side=1,line = 7, cex =.8, adj=.7)
  par(fig=c(0,0.8,0,0.8), new=TRUE)    #creates a new plot

}  # end for (cnt in 1:CatBins$plotCnt)
#savePlot  -- saves to file a png?
  par(op)
end
}
